if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Usp_Errorlog_Notification]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[Usp_Errorlog_Notification]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[sp_send_cdosysmail]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[sp_send_cdosysmail]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ErrorlogForceInclude]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[ErrorlogForceInclude]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ErrorlogScanExclude]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[ErrorlogScanExclude]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ErrorlogScanKeyword]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[ErrorlogScanKeyword]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ErrorsP1]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[ErrorsP1]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ErrorsP2]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[ErrorsP2]
GO

CREATE TABLE dbo.ErrorlogForceInclude
(   [Forcekeyword] varchar(255) NOT NULL
) ON [PRIMARY]
GO
--
-- TABLE INSERT STATEMENTS
--
INSERT INTO dbo.ErrorlogForceInclude ( Forcekeyword ) 
		 VALUES ( 'root' ) 
GO
INSERT INTO dbo.ErrorlogForceInclude ( Forcekeyword ) 
		 VALUES ( 'admin' ) 
GO
INSERT INTO dbo.ErrorlogForceInclude ( Forcekeyword ) 
		 VALUES ( 'sa' ) 
GO

CREATE TABLE dbo.ErrorlogScanExclude
(   [Excludekeyword] varchar(255) NOT NULL
) ON [PRIMARY]
GO
--
-- TABLE INSERT STATEMENTS
--
INSERT INTO dbo.ErrorlogScanExclude ( Excludekeyword ) 
		 VALUES ( '1073759' ) 
GO
INSERT INTO dbo.ErrorlogScanExclude ( Excludekeyword ) 
		 VALUES ( '15457' ) 
GO
INSERT INTO dbo.ErrorlogScanExclude ( Excludekeyword ) 
		 VALUES ( '50000' ) 
GO
INSERT INTO dbo.ErrorlogScanExclude ( Excludekeyword ) 
		 VALUES ( '60000' ) 
GO
INSERT INTO dbo.ErrorlogScanExclude ( Excludekeyword ) 
		 VALUES ( 'Login failed for user' ) 
GO

CREATE TABLE dbo.ErrorlogScanKeyword
(	[keyword] varchar(255) NOT NULL
) ON [PRIMARY]
GO

--
-- TABLE INSERT STATEMENTS
--
INSERT INTO dbo.ErrorlogScanKeyword ( keyword ) 
		 VALUES ( 'cannot obtain a LOCK' ) 
GO
INSERT INTO dbo.ErrorlogScanKeyword ( keyword ) 
		 VALUES ( 'Error:' ) 
GO
INSERT INTO dbo.ErrorlogScanKeyword ( keyword ) 
		 VALUES ( 'failed' ) 
GO
INSERT INTO dbo.ErrorlogScanKeyword ( keyword ) 
		 VALUES ( 'Victim Resource' ) 
GO
INSERT INTO dbo.ErrorlogScanKeyword ( keyword ) 
		 VALUES ( 'Expire' ) 
GO
INSERT INTO dbo.ErrorlogScanKeyword ( keyword ) 
		 VALUES ( 'stack' ) 
GO
INSERT INTO dbo.ErrorlogScanKeyword ( keyword ) 
		 VALUES ( 'CImageHelper' ) 
GO
INSERT INTO dbo.ErrorlogScanKeyword ( keyword ) 
		 VALUES ( 'is full' ) 
GO
INSERT INTO dbo.ErrorlogScanKeyword ( keyword ) 
		 VALUES ( 'cannot find' ) 
GO
INSERT INTO dbo.ErrorlogScanKeyword ( keyword ) 
		 VALUES ( 'hung' ) 
GO
INSERT INTO dbo.ErrorlogScanKeyword ( keyword ) 
		 VALUES ( 'WARNING' ) 
GO
INSERT INTO dbo.ErrorlogScanKeyword ( keyword ) 
		 VALUES ( 'Unable' ) 
GO
INSERT INTO dbo.ErrorlogScanKeyword ( keyword ) 
		 VALUES ( 'Could not allocate new page' ) 
GO
INSERT INTO dbo.ErrorlogScanKeyword ( keyword ) 
		 VALUES ( 'attempting to unlock unowned' ) 
GO

CREATE TABLE dbo.ErrorsP1
(   [Error_Message] varchar(255) NOT NULL,
    [Error_Date]    char(22)     NOT NULL,
    [SPID]          varchar(15)  NOT NULL
) ON [PRIMARY]
GO

CREATE TABLE dbo.ErrorsP2
(   [Error_Message] varchar(255) NOT NULL,
    [Error_Date]    char(22)     NOT NULL,
    [SPID]          varchar(15)  NOT NULL
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Email_Addresses] (
	[Email_Address] [varchar] (60) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[alert_function] [char] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY]
GO

INSERT INTO dbo.Email_Addresses ( Email_Address, alert_function ) 
		 VALUES ( 'someone@yourcompany.com', 'errorlog' ) 
go

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

CREATE procedure [dbo].[sp_send_cdosysmail]
   @From varchar(100)=null ,
   @To varchar(100) ,
   @Subject varchar(100)=" ",
   @Body varchar(4000) =" "
/*********************************************************************

This stored procedure takes the above parameters and sends an e-mail.
All of the mail configurations are hard-coded in the stored procedure.
Comments are added to the stored procedure where necessary.
Reference to the CDOSYS objects are at the following MSDN Web site:
http://msdn.microsoft.com/library/default.asp?
url=/library/en-us/cdosys/html/_cdosys_messaging.asp

***********************************************************************/
   AS
   Declare @iMsg int
   Declare @hr int
   Declare @source varchar(255)
   Declare @description varchar(500)
   Declare @output varchar(1000)
if @from = null
begin
   select @from=@@servername
end
--************* Create the CDO.Message Object ************************
   EXEC @hr = sp_OACreate 'CDO.Message', @iMsg OUT

--***************Configuring the Message Object ******************
-- This is to configure a remote SMTP server.
-- http://msdn.microsoft.com/library/default.asp?url=/library/en-us/cdosys/html/_cdosys_schema_configuration_sendusing.asp
   EXEC @hr = sp_OASetProperty @iMsg,'Configuration.fields("http://schemas.microsoft.com/cdo/configuration/sendusing").Value','2'
-- This is to configure the Server Name or IP address.
-- Replace MailServerName by the name or IP of your SMTP Server.
   EXEC @hr = sp_OASetProperty @iMsg,'Configuration.fields("http://schemas.microsoft.com/cdo/configuration/smtpserver").Value','SMTP01'

-- Save the configurations to the message object.
   EXEC @hr = sp_OAMethod @iMsg, 'Configuration.Fields.Update', null

-- Set the e-mail parameters.
   EXEC @hr = sp_OASetProperty @iMsg, 'To', @To
   EXEC @hr = sp_OASetProperty @iMsg, 'From', @From
   EXEC @hr = sp_OASetProperty @iMsg, 'Subject', @Subject

-- If you are using HTML e-mail, use 'HTMLBody' instead of 'TextBody'.
   EXEC @hr = sp_OASetProperty @iMsg, 'TextBody', @Body
   EXEC @hr = sp_OAMethod @iMsg, 'Send', NULL

-- Sample error handling.
   IF @hr <>0
     BEGIN
       EXEC @hr = sp_OAGetErrorInfo NULL, @source OUT, @description OUT
       IF @hr = 0
         BEGIN
           SELECT @output = '  Source: ' + @source
           PRINT  @output
           SELECT @output = '  Description: ' + @description
           PRINT  @output
         END
       ELSE
         BEGIN
           PRINT '  sp_OAGetErrorInfo failed.'
           RETURN
         END
     END

-- Do some error handling after each step if you need to.
-- Clean up the objects created.
   EXEC @hr = sp_OADestroy @iMsg

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


CREATE function [dbo].[udf_ValidErrorlogDate] (@error_date char(22),@today datetime)
returns varchar(40)

as
Begin
DECLARE @Valid_Date varchar(40)
select @Valid_Date='Good Date'
 
/*
if (@month in (2,4,6,9,11) and @day = 31) return (@NOT_OK)
if (@month = 2 and @day = 30) return (@NOT_OK)
*/
 
--select @error_date='D6-3500-400F-AC2D-2429'
--select @error_date='2006-04-31 00:03:46.87'
if @error_date like '____-__-__ __:__:__.__'
begin
 if substring(@error_date,1,4) not in                     -- check for valid Year
 ( convert(varchar(4),datepart(yyyy,@today)), 
   convert(varchar(4),datepart(yyyy,dateadd(yy,-1,@today)))) 
 begin
   select @Valid_Date=substring(@error_date,1,4)+':bad date year data'
 end
 if substring(@error_date,6,2) < '01' or substring(@error_date,6,2) > '12'  -- check for valid Month
 begin
   select @Valid_Date=substring(@error_date,6,2)+ ':bad date month data'
 end
 
 if substring(@error_date,9,2) < '01' or substring(@error_date,9,2) > '31'  -- check for valid Day
        and substring(@error_date,6,2) not in ('02','04','06','09','11')   
 begin
   select @Valid_Date=substring(@error_date,9,2)+ ':bad date day data, day > 31'
 end
 if substring(@error_date,9,2) < '01' or substring(@error_date,9,2) > '30'  -- check for valid Day
        and substring(@error_date,6,2)  in ('02','04','06','09','11')   
 begin
   select @Valid_Date=substring(@error_date,9,2)+ ':bad date day data, day > 30'
 end
 if substring(@error_date,9,2) < '01' or substring(@error_date,9,2) > '29'  -- check for valid Day
        and substring(@error_date,6,2)  = '02' 
 begin
   select @Valid_Date=substring(@error_date,9,2)+ ':bad date day data for Feb'
 end
 
 if substring(@error_date,12,2) < '00' or substring(@error_date,12,2) > '24'  -- check for valid Hour
 begin
   select @Valid_Date=substring(@error_date,12,2)+ ':bad date Hour data'
 end
 if substring(@error_date,15,2) < '00' or substring(@error_date,15,2) > '59'  -- check for valid Minute
 begin
   select @Valid_Date=substring(@error_date,15,2)+ ':bad date Minute data'
 end
 if substring(@error_date,18,2) < '00' or substring(@error_date,18,2) > '59'  -- check for valid Second
 begin
   select @Valid_Date=substring(@error_date,18,2)+ ':bad date Second data'
 end
end
else
begin
   select @Valid_Date='bad date format'
end

return @Valid_Date
end
go

set ANSI_NULLS ON
set QUOTED_IDENTIFIER OFF
go


ALTER PROCEDURE [dbo].[Usp_Errorlog_Notification] AS
declare @recep varchar(50), 
	@E_Mail VARCHAR(8000),
	@from varchar(100),
	@msg VARCHAR(8000)
DECLARE @Error_Message varchar(200),
	@error_date char(22),
	@RCPT VARCHAR(500)
DECLARE @spid varchar(15),
	@cnt int,
	@Cnt1 int,
	@Row_Count int,
    @Prod_ver varchar(50)
DECLARE @MxDate char(22),
	@MxDateDel char(22),
	@ErrorMsg_text varchar(255),
    @ErrorLogDate  varchar(255),
    @ErrorProcessInfo varchar(255)
DECLARE @searchForKeyword varchar(255),
	@cmd varchar(8000),
	@ForceKeyword varchar(255)

-- Frank Proto: Code modified to: Add dynamic email addresses, 
--                                handle SQL2000 & SQL2005 
--                                added ErrorlogScanKeyword, ErrorlogForceInclude 
--                                      and ErrorlogScanExclude tables
 
set nocount on
-- We need to see what version of SQL Server we are: 2000 or 2005
SELECT @Prod_ver=convert(varchar(20),SERVERPROPERTY('ProductVersion'))

-- configure the list of email addresses that will be used at the end 
-- for the errorlog notification
select @RCPT='', @msg=' ',@from = @@servername
declare rcpt_cursor cursor for  
    select Email_Address from DBA_Perform.dbo.Email_Addresses
          where alert_function='errorlog'
open  rcpt_cursor
fetch rcpt_cursor into @recep
while @@fetch_status = 0
begin
   select @RCPT=@RCPT+@recep+';'
   fetch rcpt_cursor into @recep
end
select @RCPT=substring(@RCPT,1,datalength(@RCPT)-1)
close rcpt_cursor
deallocate rcpt_cursor

-- create two temp tables to be used in the manipulation of the errorlog details
CREATE TABLE #Errors     (vchLogDate varchar(255),vchProcessInfo varchar(255),vchMessage varchar(4000))
CREATE TABLE #ErrorsHOLD (vchLogDate varchar(255),vchProcessInfo varchar(255),vchMessage varchar(4000))

if substring(@Prod_ver,1,1) = '9'          --Is this SQL2005?
begin
-- use xp_readerrorlog in order to gather all details in the current log
    INSERT #Errors Exec master..xp_readerrorlog 
end
else  --  or is this SQL2000 (No ver7 support)
begin           
    CREATE TABLE #Errors2000 (vchMessage varchar(255), ID int)
-- use xp_readerrorlog in order to gather all details in the current log
    INSERT #Errors2000 Exec master..xp_readerrorlog 
    insert #Errors select Substring(vchMessage,1,22), Substring(vchMessage, 24,7),Substring(vchMessage, 34,200) 
        from #Errors2000 where  DBA_Perform.dbo.udf_ValidErrorlogDate(Substring(vchMessage,1,22),getdate()) ='Good Date'
    drop table #Errors2000
end 

-- next, find the current max date in the ErrorsP1 table
Select @MxDateDel = Max(Error_Date) from ErrorsP1 
if @MxDateDel = null select @MxDateDel = '1900-01-01 07:22:00.00'
 
--  KEYWORDS TO SCAN FOR
select @cmd = "delete #Errors from #Errors eTmp where " 
declare KW_cursor cursor for  select "'%"+keyword+"%'" from  ErrorlogScanKeyword
open  KW_cursor
fetch KW_cursor into @searchForKeyword
select @cmd = @cmd+' vchMessage not LIKE '+@searchForKeyword
while @@fetch_status = 0
begin
 select @cmd = @cmd+' and vchMessage not LIKE '+@searchForKeyword
 fetch KW_cursor into @searchForKeyword
end
close KW_cursor
deallocate KW_cursor 
exec (@cmd)
 
delete #Errors from #Errors eTmp  where convert(datetime,vchLogDate) <= convert(datetime,@MxDateDel)

--   HOLD line with KEYWORDS TO Force Include
select @cmd = "insert #ErrorsHOLD select * from #Errors eTmp where "
declare KW_cursorH cursor for  select Forcekeyword from  ErrorlogForceInclude
open  KW_cursorH
fetch KW_cursorH into @searchForKeyword
 if @searchForKeyword != 'sa'
     begin
         select @ForceKeyword ="'%"+@searchForKeyword+"%'"
     end
 else
     begin
         select @ForceKeyword =char(34)+"%"+char(39)+@searchForKeyword+char(39)+"%"+char(34)
     end

select @cmd = @cmd+' eTmp.vchMessage LIKE '+@ForceKeyword
fetch KW_cursorH into @searchForKeyword
while @@fetch_status = 0
begin 
 if @searchForKeyword != 'sa'
     select @ForceKeyword ="'%"+@searchForKeyword+"%'"
 else
     select @ForceKeyword =char(34)+"%"+char(39)+@searchForKeyword+char(39)+"%"+char(34)

 select @cmd = @cmd+' or vchMessage LIKE '+@ForceKeyword
 fetch KW_cursorH into @searchForKeyword
end
close KW_cursorH
deallocate KW_cursorH 

exec (@cmd)

--    KEYWORDS TO EXCLUDE    
select @cmd = "delete #Errors from #Errors eTmp where " 
declare KW_cursor cursor for  select "'%"+Excludekeyword+"%'" from  ErrorlogScanExclude
open  KW_cursor
fetch KW_cursor into @searchForKeyword
select @cmd = @cmd+' vchMessage  LIKE '+@searchForKeyword
while @@fetch_status = 0
begin
 select @cmd = @cmd+' or vchMessage  LIKE '+@searchForKeyword
 fetch KW_cursor into @searchForKeyword
end
close KW_cursor
deallocate KW_cursor 
exec (@cmd)

insert #Errors select * from #ErrorsHOLD

SELECT @Row_Count = count(*) FROM #Errors   
If @Row_Count <> 0 
BEGIN
   DECLARE ErrorMsg CURSOR For Select vchLogDate,vchProcessInfo,vchMessage from #Errors 
   OPEN ErrorMsg
   FETCH NEXT from ErrorMsg into  @ErrorLogDate , @ErrorProcessInfo, @ErrorMsg_text
   Select @cnt = count(*) from ErrorsP1
   If @cnt = 0 
      Begin

	     WHILE ( @@fetch_status = 0 )
	     BEGIN
	        Select @Error_Message =  @ErrorMsg_text

	        Select @error_date = @ErrorLogDate
	        Select @spid = @ErrorProcessInfo
            if @error_date is not null
            begin
	            Insert into ErrorsP1 values (@Error_Message, @error_date, @spid)
            end

            select @msg=@msg+convert(varchar(23),@error_date)+' '+@Error_Message+
                        ' from:'+@spid+ CHAR(13) + CHAR(10)

            FETCH NEXT from ErrorMsg into  @ErrorLogDate , @ErrorProcessInfo, @ErrorMsg_text
    	End
   while  charindex("'",@msg) > 0
   begin
     select @msg=stuff(@msg, charindex("'",@msg),1,' '  ) 
   end

        select @E_Mail = 'EXEC DBA_Perform.dbo.sp_send_cdosysmail
            @To = ''' + @RCPT + ''',
            @from = ''' + @from + ''',
            @Body = ''' +  convert(varchar(2000),@msg) + ''',
            @subject = ''!!  errorlog messages ' + @@SERVERname + ' !!'''
        select @E_Mail            
  EXEC (@E_Mail) 
    End

else

BEGIN

	WHILE ( @@fetch_status = 0 )
	BEGIN
       Select @Error_Message =  @ErrorMsg_text
       Select @error_date = @ErrorLogDate
       Select @spid = @ErrorProcessInfo
       if @error_date is not null
       begin
	        Insert into ErrorsP2 values (@Error_Message, @error_date, @spid) --real
       end     

       select @msg=@msg+convert(varchar(23),@error_date)+' '+@Error_Message+' '+@spid+ CHAR(13) + CHAR(10)
	   FETCH NEXT from ErrorMsg into  @ErrorLogDate , @ErrorProcessInfo, @ErrorMsg_text
	End    
    Select @MxDate = Max(Error_Date) from ErrorsP1
    Select @Cnt1 = Count(*) from ErrorsP2 where Error_Date > ( Select Max(Error_Date) from ErrorsP1)
    If @Cnt1 <> 0 
       BEGIN 

          truncate table ErrorsP1
          insert  ErrorsP1 select * from ErrorsP2 where Error_Date > @MxDate --real
      while  charindex("'",@msg) > 0
      begin
         select @msg=stuff(@msg, charindex("'",@msg),1,' '  ) 
      end

          select @E_Mail = 'EXEC DBA_Perform.dbo.sp_send_cdosysmail
            @To = ''' + @RCPT + ''',
            @from = ''' + @from + ''',
            @Body = ''' + convert(varchar(2000),@msg) + ''',
            @subject = ''!!  errorlog messages ' + @@SERVERname + ' !!'''

         EXEC (@E_Mail)
--       Truncating because no recent recs found
         Truncate table ErrorsP2 
       End

    End 

    Close ErrorMsg
    Deallocate ErrorMsg
END
else
Begin
  Print 'No Errors in the Error Logs'
end
Drop table #Errors
Drop table #ErrorsHOLD
GO



USE [msdb]
GO

BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0

IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'DBA_Perform Job' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'DBA_Perform Job'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'Scan Errorlog', 
		@enabled=1, 
		@notify_level_eventlog=2, 
		@notify_level_email=0, 
		@notify_level_netsend=0, 
		@notify_level_page=0, 
		@delete_level=0, 
		@description=N'No description available.', 
		@category_name=N'DBA_Perform Job', 
		@owner_login_name=N'sa', @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N's1', 
		@step_id=1, 
		@cmdexec_success_code=0, 
		@on_success_action=1, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=1, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'exec Usp_Errorlog_Notification', 
		@database_name=N'DBA_Perform', 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'sched1', 
		@enabled=1, 
		@freq_type=4, 
		@freq_interval=1, 
		@freq_subday_type=4, 
		@freq_subday_interval=10, 
		@freq_relative_interval=0, 
		@freq_recurrence_factor=0, 
		@active_start_date=20040128, 
		@active_end_date=99991231, 
		@active_start_time=0, 
		@active_end_time=235959
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
	IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:



